"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs-extra");
var utils_1 = require("./utils");
var createClient = require('contentful-management').createClient;
function loadSources(args) {
    return Promise.all([
        loadSource(args.from, args),
        loadSource(args.to, args),
    ]);
}
exports.loadSources = loadSources;
function loadSource(source, args) {
    return __awaiter(this, void 0, void 0, function () {
        var contentTypes, editorInterfaces, contents, parsed, client, _a, spaceId, envId, env, space, e_1, space;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(source == 'scratch' || source == 'empty')) return [3 /*break*/, 1];
                    // used to create migrations for a space from scratch
                    contentTypes = [];
                    editorInterfaces = [];
                    return [3 /*break*/, 14];
                case 1: return [4 /*yield*/, fs.pathExists(source)];
                case 2:
                    if (!_b.sent()) return [3 /*break*/, 4];
                    return [4 /*yield*/, fs.readFile(source)];
                case 3:
                    contents = _b.sent();
                    parsed = JSON.parse(contents.toString());
                    contentTypes = parsed.contentTypes;
                    editorInterfaces = parsed.editorInterfaces;
                    return [3 /*break*/, 14];
                case 4:
                    // get from space
                    if (!args.managementToken) {
                        throw new Error(source + " is not a file and I don't have a management token to talk to contentful.");
                    }
                    client = createClient({
                        accessToken: args.managementToken
                    });
                    _a = parseEnv(source), spaceId = _a.spaceId, envId = _a.envId;
                    env = void 0;
                    _b.label = 5;
                case 5:
                    _b.trys.push([5, 8, , 11]);
                    return [4 /*yield*/, client.getSpace(spaceId)];
                case 6:
                    space = _b.sent();
                    return [4 /*yield*/, space.getEnvironment(envId)];
                case 7:
                    env = _b.sent();
                    return [3 /*break*/, 11];
                case 8:
                    e_1 = _b.sent();
                    // the source may not be a space - it might be an environment on the '--from' space
                    if (args.from == source) {
                        throw (e_1);
                    }
                    // we're loading the args.to
                    spaceId = parseEnv(args.from).spaceId;
                    envId = source;
                    return [4 /*yield*/, client.getSpace(spaceId)];
                case 9:
                    space = _b.sent();
                    return [4 /*yield*/, space.getEnvironment(envId)];
                case 10:
                    env = _b.sent();
                    return [3 /*break*/, 11];
                case 11: return [4 /*yield*/, env.getContentTypes()];
                case 12:
                    contentTypes = (_b.sent()).items;
                    if (args.contentTypes && args.contentTypes.length > 0) {
                        contentTypes = contentTypes.filter(function (ct) {
                            return args.contentTypes.indexOf(ct.sys.id) >= 0;
                        });
                    }
                    return [4 /*yield*/, utils_1.eachInSequence(contentTypes, function (ct) { return ct.getEditorInterface(); })];
                case 13:
                    editorInterfaces = _b.sent();
                    _b.label = 14;
                case 14: return [2 /*return*/, {
                        id: source,
                        contentTypes: contentTypes,
                        editorInterfaces: editorInterfaces
                    }];
            }
        });
    });
}
function parseEnv(source) {
    var parts = source.split('/');
    return {
        spaceId: parts[0],
        envId: parts.length > 1 ? parts[1] : 'master'
    };
}
//# sourceMappingURL=source.js.map